Index: /Dev/branches/rest-dojo-ui/client/rft/pages/session.html
===================================================================
--- /Dev/branches/rest-dojo-ui/client/rft/pages/session.html	(revision 368)
+++ /Dev/branches/rest-dojo-ui/client/rft/pages/session.html	(revision 369)
@@ -28,7 +28,4 @@
                             <label for="accountsInput">Add new</label>
                             <select id="accountBox"></select>
-                            <!--
-                            <input type="text" data-rft-attach-point="emailBox" data-dojo-type="dijit.form.TextBox" data-dojo-props="placeHolder: 'Enter email address here...'" />
-                            -->
                             <button data-rft-attach-point="btnInvite" data-dojo-type="dijit.form.Button" data-rft-attach-event="onClick:onInvite" data-dojo-props="baseClass: 'rftBlockButton', class: 'green', iconClass: 'rftIcon rftIconPlus'">Invite</button>
                             <br/><br/>
@@ -36,10 +33,4 @@
                             <div data-rft-attach-point="listViewNode" class="rftLineListView">
                             </div>
-                            <!--
-                            <div data-dojo-type="rft.ui.List" data-dojo-props="region:'center'" style="width: 500px;">
-                                <div data-dojo-type="rft.ui.LineWithActionsWidget" data-dojo-props="title:'a.bezuijen@tudelft.nl', modifiers: 'green', actions: {'Cancel':{callback: function(){}, properties: {blockButton: false, icon: 'Delete', modifiers:'white'}}}"></div>
-                                <div data-dojo-type="rft.ui.LineWithActionsWidget" data-dojo-props="title:'i.mayer@tudelft.nl', modifiers: 'green', actions: {'Cancel':{callback: function(){}, properties: {blockButton: false, icon: 'Delete', modifiers:'white'}}}"></div>
-                            </div>
-                            -->
                         </fieldset>
 
Index: /Dev/branches/rest-dojo-ui/client/rft/pages/session.js
===================================================================
--- /Dev/branches/rest-dojo-ui/client/rft/pages/session.js	(revision 368)
+++ /Dev/branches/rest-dojo-ui/client/rft/pages/session.js	(revision 369)
@@ -15,4 +15,5 @@
 			_listView: null,
             _select: null,
+            _accounts: null,
 			onVisit: function() {
 				if ( this.pageArgs.uid ) {
@@ -20,8 +21,9 @@
 					.then(lang.hitch(this,function(obj){
 						this.session = obj;
+                        this._setupListView();
                         this._refresh();
 					}));
                     this._setupAutoComplete();
-                    this._setupListView();
+                    this._accounts = [];
 				} else {
 					throw "No valid uid or session passed!";
@@ -36,9 +38,10 @@
             },
             onInvite: function() {
-                this._addAccount({ title : this._select.displayedValue });
+                this._addAccount(this._select.item.i);
                 this._select.reset();
             },
             onSave: function(evt) {
                 lang.mixin(this.session,this.propertiesForm.get('value'));
+                this.session.accounts = this._accounts;
                 store.put(this.session)
                 .then(function(){
@@ -55,4 +58,5 @@
             },
             _addAccount: function(item) {
+                this._accounts.push(item);
                 this._listView.insertItem(item);
             },
@@ -61,4 +65,8 @@
                     controller: this
                 }).placeAt(this.listViewNode);
+                for (account in this.session.accounts) {
+                    this._accounts.push(this.session.accounts[account]);
+                    this._listView.insertItem({ "title" : this.session.accounts[account] });
+                }
                 this._listView.startup();
             },
Index: /Dev/branches/rest-dojo-ui/client/rft/pages/survey.html
===================================================================
--- /Dev/branches/rest-dojo-ui/client/rft/pages/survey.html	(revision 368)
+++ /Dev/branches/rest-dojo-ui/client/rft/pages/survey.html	(revision 369)
@@ -20,6 +20,6 @@
 
             <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region: 'bottom'">
-                <button data-rft-attach-point="btnProperties" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconProperties'">Properties</button>
-                <button data-rft-attach-point="btnSave" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconAccept'">Save Changes</button>
+                <button data-rft-attach-point="btnProperties" data-dojo-type="dijit.form.Button" data-rft-attach-event="onClick:onProperties" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconProperties'">Properties</button>
+                <button data-rft-attach-point="btnSave" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton' data-rft-attach-event="onClick:onSave", iconClass: 'rftIcon rftIconAccept'">Save Changes</button>
                 <button data-rft-attach-point="btnDiscard" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconCancel'">Discard changes</button>
                 <button data-rft-attach-point="btnPreview" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconPreview'">Preview</button>
Index: /Dev/branches/rest-dojo-ui/client/rft/pages/survey.js
===================================================================
--- /Dev/branches/rest-dojo-ui/client/rft/pages/survey.js	(revision 368)
+++ /Dev/branches/rest-dojo-ui/client/rft/pages/survey.js	(revision 369)
@@ -33,4 +33,16 @@
                     throw "No valid uid or survey passed!";
                 }
+            },
+            onProperties: function(evt) {
+
+            },
+            onSave: function(evt) {
+//                lang.mixin(this.object, this.propertiesForm.get('value'));
+                store.put(this.object)
+                .then(function() { 
+                    content.goTo('surveys');
+                });
+                event.stop(evt);
+                return false;
             },
             _goToPreview: function() {
@@ -101,5 +113,5 @@
             /* ListView code */
             includeQuestion: function(question) {
-                this.listView.insertItem(question);
+                var item = this.listView.insertItem(question);
             },
             _setupListView: function() {