Index: Dev/branches/rest-dojo-ui/client/rft/pages/question.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/question.html	(revision 371)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/question.html	(revision 372)
@@ -8,5 +8,4 @@
 		</div>
 		<div data-dojo-type="dijit.layout.BorderContainer" data-dojo-props="region:'left', design:'headline'" style="width: 300px;">
-			
 			<div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region:'center'">
 				<div id="QuestionEditorToolkit"></div>
Index: Dev/branches/rest-dojo-ui/client/rft/pages/question.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 371)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 372)
@@ -16,6 +16,7 @@
     function(declare, lang, Deferred, LineWithActionsWidget, store, _Page, api, content, registry, on, behavior, query){
         return declare('rft.pages.question', [_Page], {
-            object: null,
-            preview: null,
+            question: null,
+            _toolkit: null,
+            _preview: null,
             
             onVisit: function() {
@@ -23,15 +24,18 @@
                     Deferred.when(store.get(this.pageArgs.uid))
                     .then(lang.hitch(this, function(obj) {
-                        this.object = obj;
+                        this.question = obj;
+                        this._refresh();
                     }));
                 } else {
                     throw new Error("Error: no reference to object set!");
                 }
-
+                this._setupEditor();
                 this._setupButtons();
-                this._setupEditor();
             },
             onLeave: function() {
                 this.inherited(arguments);
+            },
+            _refresh: function () {
+                this._toolkit.propertiesForm.set('value', this.question);
             },
             _setupButtons: function() {
@@ -52,9 +56,10 @@
             },
             _setupEditor: function() {
-                this.toolkit = new rft.ui.QuestionEditorToolkit();
-                this.toolkit.placeAt("QuestionEditorToolkit");
+//                this.toolkit = new rft.ui.QuestionEditorToolkit( { question: this.question } );
+                this._toolkit = new rft.ui.QuestionEditorToolkit();
+                this._toolkit.placeAt("QuestionEditorToolkit");
 
-                this.preview = new rft.ui.QuestionEditorPreview();
-                this.preview.placeAt("QuestionEditorPreview");
+                this._preview = new rft.ui.QuestionEditorPreview();
+                this._preview.placeAt("QuestionEditorPreview");
             }
         });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/AccordionList.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/AccordionList.js	(revision 371)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/AccordionList.js	(revision 372)
@@ -11,5 +11,5 @@
             idProperty: null,
             categoryProperty: null,
-            titleProperty: null,
+            titleProperty: "test",
             actions: null,
             _widgets: null,
Index: Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 371)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 372)
@@ -14,4 +14,6 @@
 
 			templateString: template,
+			question: null,
+
 			postCreate: function(){
 				this.contentSource = new dojo.dnd.Source(this.ToolkitContentSourceNode, {
Index: Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html	(revision 371)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html	(revision 372)
@@ -2,13 +2,13 @@
 	<div data-dojo-type="dijit.layout.AccordionContainer" class="orange">
 		<div data-dojo-type="dijit.layout.ContentPane" title="Properties" data-dojo-props="iconClass:'rftIcon rftIconProperties'">
-			<form id="propertiesForm">
+            <div id="propertiesForm" data-dojo-type="dijit.form.Form" data-dojo-attach-point="propertiesForm" data-rft-attach-event="onSubmit:onSave">
 				<fieldset class="align">
-					<label for="propertiesTitle">Title:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesTitle"/>
-					<label for="propertiesCode">Code:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesCode"/>
-					<label for="propertiesCategories">Categories:</label><input data-dojo-type="dijit.form.FilteringSelect" id="propertiesCategories"/>
-					<label for="propertiesTopic">Topic:</label><input data-dojo-type="dijit.form.FilteringSelect" id="propertiesTopic"/>
-					<label for="propertiesDescription">Description:</label><textarea data-dojo-type="dijit.form.Textarea" id="propertiesDescription"></textarea>
+					<label for="propertiesTitle">Title:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesTitle" name="title"/>
+					<label for="propertiesCode">Code:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesCode" name= "code"/>
+					<label for="propertiesCategories">Categories:</label><input data-dojo-type="dijit.form.FilteringSelect" id="propertiesCategories" name="categories"/>
+					<label for="propertiesTopic">Topic:</label><input data-dojo-type="dijit.form.FilteringSelect" id="propertiesTopic" name="topic"/>
+					<label for="propertiesDescription">Description:</label><textarea data-dojo-type="dijit.form.Textarea" id="propertiesDescription" name="description"></textarea>
 				</fieldset>
-			</form>
+			</div>
 		</div>
 