Index: Dev/branches/rest-dojo-ui/client/rft/ui/AccountListView.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/AccountListView.js	(revision 372)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/AccountListView.js	(revision 373)
@@ -17,8 +17,8 @@
         _Container,
         LineWithActionsWidget,
-        ListView,
+        OrderedList,
         templateString
 		) {
-        return declare('rft.ui.AccountListView',[ListView,_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
+        return declare('rft.ui.AccountListView',[OrderedList,_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
             templateString: templateString,
             baseClass: 'rftLineListView',
Index: Dev/branches/rest-dojo-ui/client/rft/ui/ListView.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/ListView.js	(revision 372)
+++ 	(revision )
@@ -1,109 +1,0 @@
-define([
-    'dojo/_base/declare',
-    'dojo/_base/lang',
-    'dijit/_WidgetBase',
-    'dijit/_TemplatedMixin',
-    'dijit/_WidgetsInTemplateMixin',
-    'dijit/_Container',
-    'dojo/text!./templates/List.html'
-    ],function(
-        declare,
-        lang,
-        _WidgetBase,
-        _TemplatedMixin,
-        _WidgetsInTemplateMixin,
-        _Container,
-        templateString
-        ){
-        return declare('rft.ui.List',[_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
-            templateString: templateString,
-            baseClass: 'rftList',
-
-            removeCallback: null,
-
-            constructor: function() {
-                lang.mixin(this, arguments);
-            },
-
-            postCreate: function() {
-                if (this.title) {
-                    this.titleNode.innerHTML = this.title;
-                } else {
-                    this.domNode.removeChild(this.titleNode);
-                }
-
-                this.source = new dojo.dnd.Source(this.sourceNode, {
-                    isSource: true,
-                    accept: ["LineListViewItem"],
-                    horizontal: false,
-                    withHandles: false,
-                    copyOnly: false,
-                    selfCopy: false,
-                    selfAccept: true,
-                    delay: 0,
-                    singular: true,
-                    creator: lang.hitch(this, this.creatorMethod)
-                });
-
-                new dijit.form.Button({
-                    label: "Move up",
-                    showLabel: false,
-                    iconClass: "rftIcon rftIconFullArrowUp",
-                    baseClass: "rftBlockButton",
-                    'class': "trans",
-                    onClick: lang.hitch(this, function() {
-                        this.moveItem("up");
-                    })
-                }, this.btnListMoveUp);
-
-                new dijit.form.Button({
-                    label: "Move down",
-                    showLabel: false,
-                    iconClass: "rftIcon rftIconFullArrowDown",
-                    baseClass: "rftBlockButton",
-                    'class': "trans",
-                    onClick: lang.hitch(this, function() {
-                        this.moveItem("down");
-                    })
-                }, this.btnListMoveDown); 
-            },
-
-            moveItem: function(dir) {
-                var node = this.source.getSelectedNodes()[0];
-                if (node) {
-                    if (dir == "up") {
-                        if (node.previousSibling) {
-                            return node.parentNode.insertBefore(node, node.previousSibling);
-                        } else {
-                            return false;
-                        }
-
-                    } else if (dir == "down") {
-                        if (node.nextSibling) {
-                            return node.parentNode.insertBefore(node.nextSibling, node);
-                        } else {
-                            return false;
-                        }
-                    } else {
-                        throw "Invalid move direction passed!";
-                    }
-                } else {
-                    return false;
-                }
-            },
-
-            insertItem: function(item) {
-                var anchor = this.source.getSelectedNodes()[0];
-                if (anchor) {
-                    this.source.insertNodes(false, [item], false, anchor);
-                } else {
-                    this.source.insertNodes(false, [item]);
-                }
-            },
-            removeItem: function(item, widget) {
-                widget.destroy();
-                if(this.removeCallback)
-                    this.removeCallback(item);
-            }
-        });
-    });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/OrderedList.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/OrderedList.js	(revision 373)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/OrderedList.js	(revision 373)
@@ -0,0 +1,109 @@
+define([
+    'dojo/_base/declare',
+    'dojo/_base/lang',
+    'dijit/_WidgetBase',
+    'dijit/_TemplatedMixin',
+    'dijit/_WidgetsInTemplateMixin',
+    'dijit/_Container',
+    'dojo/text!./templates/List.html'
+    ],function(
+        declare,
+        lang,
+        _WidgetBase,
+        _TemplatedMixin,
+        _WidgetsInTemplateMixin,
+        _Container,
+        templateString
+        ){
+        return declare('rft.ui.List',[_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
+            templateString: templateString,
+            baseClass: 'rftList',
+
+            removeCallback: null,
+
+            constructor: function() {
+                lang.mixin(this, arguments);
+            },
+
+            postCreate: function() {
+                if (this.title) {
+                    this.titleNode.innerHTML = this.title;
+                } else {
+                    this.domNode.removeChild(this.titleNode);
+                }
+
+                this.source = new dojo.dnd.Source(this.sourceNode, {
+                    isSource: true,
+                    accept: ["LineListViewItem"],
+                    horizontal: false,
+                    withHandles: false,
+                    copyOnly: false,
+                    selfCopy: false,
+                    selfAccept: true,
+                    delay: 0,
+                    singular: true,
+                    creator: lang.hitch(this, this.creatorMethod)
+                });
+
+                new dijit.form.Button({
+                    label: "Move up",
+                    showLabel: false,
+                    iconClass: "rftIcon rftIconFullArrowUp",
+                    baseClass: "rftBlockButton",
+                    'class': "trans",
+                    onClick: lang.hitch(this, function() {
+                        this.moveItem("up");
+                    })
+                }, this.btnListMoveUp);
+
+                new dijit.form.Button({
+                    label: "Move down",
+                    showLabel: false,
+                    iconClass: "rftIcon rftIconFullArrowDown",
+                    baseClass: "rftBlockButton",
+                    'class': "trans",
+                    onClick: lang.hitch(this, function() {
+                        this.moveItem("down");
+                    })
+                }, this.btnListMoveDown); 
+            },
+
+            moveItem: function(dir) {
+                var node = this.source.getSelectedNodes()[0];
+                if (node) {
+                    if (dir == "up") {
+                        if (node.previousSibling) {
+                            return node.parentNode.insertBefore(node, node.previousSibling);
+                        } else {
+                            return false;
+                        }
+
+                    } else if (dir == "down") {
+                        if (node.nextSibling) {
+                            return node.parentNode.insertBefore(node.nextSibling, node);
+                        } else {
+                            return false;
+                        }
+                    } else {
+                        throw "Invalid move direction passed!";
+                    }
+                } else {
+                    return false;
+                }
+            },
+
+            insertItem: function(item) {
+                var anchor = this.source.getSelectedNodes()[0];
+                if (anchor) {
+                    this.source.insertNodes(false, [item], false, anchor);
+                } else {
+                    this.source.insertNodes(false, [item]);
+                }
+            },
+            removeItem: function(item, widget) {
+                widget.destroy();
+                if(this.removeCallback)
+                    this.removeCallback(item);
+            }
+        });
+    });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/templates/ListView.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/templates/ListView.html	(revision 372)
+++ 	(revision )
@@ -1,9 +1,0 @@
-<div>
-	<h3 data-dojo-attach-point="titleNode"></h3>
-	<div data-dojo-attach-point="sourceNode" id="source" class="${baseClass}Content"></div>
-	<div data-dojo-attach-point="buttonsNode" class="floatRight">
-		<span>Move selected: </span>
-		<button data-dojo-attach-point="btnListMoveUp" ></button>
-		<button data-dojo-attach-point="btnListMoveDown"></button>
-	</div>
-</div>
Index: Dev/branches/rest-dojo-ui/client/rft/ui/templates/OrderedList.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/templates/OrderedList.html	(revision 373)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/templates/OrderedList.html	(revision 373)
@@ -0,0 +1,9 @@
+<div>
+	<h3 data-dojo-attach-point="titleNode"></h3>
+	<div data-dojo-attach-point="sourceNode" id="source" class="${baseClass}Content"></div>
+	<div data-dojo-attach-point="buttonsNode" class="floatRight">
+		<span>Move selected: </span>
+		<button data-dojo-attach-point="btnListMoveUp" ></button>
+		<button data-dojo-attach-point="btnListMoveDown"></button>
+	</div>
+</div>