Index: Dev/branches/rest-dojo-ui/client/rft/css/layout.css
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/css/layout.css	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/css/layout.css	(revision 377)
@@ -288,5 +288,4 @@
 }
 .claro .dijitAccordionContainer {
-    height: 600;
     /* No styling for now, use this for margins and other layout-related business. This class does not affect the look of the AccordionContainer currently! */
 }
Index: Dev/branches/rest-dojo-ui/client/rft/pages/question.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/question.html	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/question.html	(revision 377)
@@ -11,5 +11,5 @@
 				<div id="QuestionEditorToolkit"></div>
 			</div>
-			<div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region:'bottom'">
+			<div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region:'top'">
 				<button id="btnDiscard" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconCancel'">Discard</button>
 				<button id="btnSave" data-dojo-type="dijit.form.Button" data-dojo-props="baseClass: 'rftLargeButton', iconClass: 'rftIcon rftIconAccept'">Save and exit</button>
Index: Dev/branches/rest-dojo-ui/client/rft/pages/question.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/question.js	(revision 377)
@@ -49,9 +49,9 @@
                     content.goTo('questions');
                 });
-                return false;
+                return true;
             },
             _onDiscard: function() {
                 content.goTo('questions');
-                return false;
+                return true;
             },
             _setupButtons: function() {
@@ -77,4 +77,5 @@
                 this._preview = new rft.ui.QuestionEditorPreview();
                 this._preview.placeAt("QuestionEditorPreview");
+                this._supportingWidgets.push(this._toolkit, this._preview);
             }
         });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorPreview.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorPreview.js	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorPreview.js	(revision 377)
@@ -37,5 +37,5 @@
 					case "avatar":
 					node = document.createElement("span");
-					node.innerHTML = item.title || "Dragging!!!";
+					node.innerHTML = item.item.data || "Dragging!!!";
 					return {node: node, data: item, type: "PreviewItem"};
 					break;
Index: Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 377)
@@ -104,4 +104,5 @@
 					searchAttr: "id"
 				}, "categoriesBox");
+				this._supportingWidgets.push(this._categorySelect);
 
             },
@@ -119,4 +120,5 @@
 					value: topic
 				}, "topicBox");
+				this._supportingWidgets.push(this._topicSelect);
             },
 			_addCategory: function(item) {
Index: Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html	(revision 376)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/templates/QuestionEditorToolkit.html	(revision 377)
@@ -1,21 +1,21 @@
 <div>
-	<div data-dojo-type="dijit.layout.AccordionContainer" class="orange">
-		<div data-dojo-type="dijit.layout.ContentPane" title="Properties" data-dojo-props="iconClass:'rftIcon rftIconProperties'">
-            <div id="propertiesForm" data-dojo-type="dijit.form.Form" data-dojo-attach-point="propertiesForm" data-rft-attach-event="onSubmit:onSave">
+	<div data-dojo-type="dojox.widget.TitleGroup">
+		<div data-dojo-type="dijit.TitlePane" class="orange" open="true" title="Properties" data-dojo-props="iconClass:'rftIcon rftIconProperties'">
+            <div data-dojo-type="dijit.form.Form" data-dojo-attach-point="propertiesForm" data-rft-attach-event="onSubmit:onSave">
 				<fieldset class="align">
-					<label for="propertiesTitle">Title:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesTitle" name="title"/>
-					<label for="propertiesCode">Code:</label><input data-dojo-type="dijit.form.TextBox" id="propertiesCode" name= "_id"/>
-					<label for="propertiesCategories">Categories:</label>
+					<label>Title:</label><input data-dojo-type="dijit.form.TextBox" data-dojo-attach-point="propertiesTitle" name="title"/>
+					<label>Code:</label><input data-dojo-type="dijit.form.TextBox" data-dojo-attach-point="propertiesCode" name= "_id"/>
+					<label>Categories:</label>
 					<div data-dojo-attach-point="listNode" class="rftLineListView"></div> 
 					<select id="categoriesBox"></select>
 					<button data-rft-attach-point="btnCategory" data-dojo-type="dijit.form.Button" data-dojo-attach-event="onClick:onCategoryAdd" data-dojo-props="baseClass:'rftBlockButton', class:'orange', iconClass: 'rftIcon rftIconPlus'">Add</button><br>
-					<label for="propertiesTopic">Topic:</label>
+					<label>Topic:</label>
 					<select id="topicBox"></select>
-					<label for="propertiesDescription">Description:</label><textarea data-dojo-type="dijit.form.TextBox" id="propertiesDescription" name="description"></textarea>
+					<label>Description:</label><textarea data-dojo-type="dijit.form.TextBox" data-dojo-attach-point="propertiesDescription" name="description"></textarea>
 				</fieldset>
 			</div>
 		</div>
 
-		<div data-dojo-type="dijit.layout.ContentPane" title="Content" data-dojo-props="iconClass:'rftIcon rftIconPlus'">
+		<div data-dojo-type="dijit.TitlePane" open="false" title="Content" data-dojo-props="iconClass:'rftIcon rftIconPlus'">
 			<div data-dojo-attach-point="ToolkitContentSourceNode">
 				
@@ -23,5 +23,5 @@
 		</div>
 
-		<div data-dojo-type="dijit.layout.ContentPane" title="Inputs" data-dojo-props="iconClass:'rftIcon rftIconInput'">
+		<div data-dojo-type="dijit.TitlePane" open="false" title="Inputs" data-dojo-props="iconClass:'rftIcon rftIconInput'">
 			<div data-dojo-attach-point="ToolkitInputsSourceNode">
 				